﻿// -----------------------------------------------------------------------
//  <last-editor>黄深</last-editor>
//  <last-date>2023-02-01 11:23</last-date>
// -----------------------------------------------------------------------

namespace KingMetalTemplateProject.Presentation.Api.Extensions;

/// <summary>
///     WebApplication Extensions
/// </summary>
public static class WebApplicationExtensions
{
    /// <summary>
    ///     Configuration Web
    /// </summary>
    /// <param name="builder"></param>
    /// <returns></returns>
    public static WebApplicationBuilder ConfigurationWeb(this WebApplicationBuilder builder)
    {
        builder.RegisterOptions()
            .RegisterApiServices()
            .RegisterHttpClients()
            .RegisterDataConnection();

        return builder;
    }

    /// <summary>
    ///     register Options
    /// </summary>
    /// <param name="builder"></param>
    /// <returns></returns>
    private static WebApplicationBuilder RegisterOptions(this WebApplicationBuilder builder)
    {
        builder.Services.Configure<HuangsOptions>(builder.Configuration.GetSection(nameof(HuangsOptions)));

        return builder;
    }

    /// <summary>
    ///     register ApiServices
    /// </summary>
    /// <param name="builder"></param>
    /// <returns></returns>
    private static WebApplicationBuilder RegisterApiServices(this WebApplicationBuilder builder)
    {
        builder.Services.AddApiServices();

        return builder;
    }

    /// <summary>
    ///     register HttpClient
    /// </summary>
    /// <param name="builder"></param>
    /// <returns></returns>
    private static WebApplicationBuilder RegisterHttpClients(this WebApplicationBuilder builder)
    {
        builder.Services.AddHttpClientServices(builder.Configuration);

        return builder;
    }

    /// <summary>
    ///     register DataConnection
    /// </summary>
    /// <param name="builder"></param>
    /// <returns></returns>
    private static WebApplicationBuilder RegisterDataConnection(this WebApplicationBuilder builder)
    {
        builder.Services.AddDataConnection(builder.Configuration);

        return builder;
    }
}